/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : RxBuf3.c
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : RingBufferUInt8
**     Version     : Component 01.003, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-12-29, 12:12, # CodeGen: 227
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         Put             - byte RxBuf3_Put(byte elem);
**         Get             - byte RxBuf3_Get(byte *elemP);
**         NofElements     - byte RxBuf3_NofElements(void);
**         NofFreeElements - byte RxBuf3_NofFreeElements(void);
**         Init            - void RxBuf3_Init(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     This an open source software of an embedded component for Processor Expert.
**     This is a free software and is opened for education,  research  and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

/* MODULE RxBuf3. */

#include "RxBuf3.h"

static uint8_t RxBuf3_buffer[RxBuf3_BUF_SIZE]; /* ring buffer */
static uint8_t RxBuf3_inIdx;  /* input index */
static uint8_t RxBuf3_outIdx; /* output index */
static uint8_t RxBuf3_inSize; /* size of input data */
/*
** ===================================================================
**     Method      :  RxBuf3_Put (component RingBufferUInt8)
**
**     Description :
**         Puts a new element into the buffer
**     Parameters  :
**         NAME            - DESCRIPTION
**         elem            - New element to be put into the buffer
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RxBuf3_Put(byte elem)
{
  byte res = ERR_OK;

  EnterCritical();
  if (RxBuf3_inSize==RxBuf3_BUF_SIZE) {
    res = ERR_TXFULL;
  } else {
    RxBuf3_buffer[RxBuf3_inIdx] = elem;
    RxBuf3_inSize++;
    RxBuf3_inIdx++;
    if (RxBuf3_inIdx==RxBuf3_BUF_SIZE) {
      RxBuf3_inIdx = 0;
    }
  }
  ExitCritical();
  return res;
}

/*
** ===================================================================
**     Method      :  RxBuf3_Get (component RingBufferUInt8)
**
**     Description :
**         Removes an element from the buffer
**     Parameters  :
**         NAME            - DESCRIPTION
**       * elemP           - Pointer to where to store the received
**                           element
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte RxBuf3_Get(byte *elemP)
{
  byte res = ERR_OK;

  EnterCritical();
  if (RxBuf3_inSize==0) {
    res = ERR_RXEMPTY;
  } else {
    *elemP = RxBuf3_buffer[RxBuf3_outIdx];
    RxBuf3_inSize--;
    RxBuf3_outIdx++;
    if (RxBuf3_outIdx==RxBuf3_BUF_SIZE) {
      RxBuf3_outIdx = 0;
    }
  }
  ExitCritical();
  return res;
}

/*
** ===================================================================
**     Method      :  RxBuf3_NofElements (component RingBufferUInt8)
**
**     Description :
**         Returns the actual number of elements in the buffer.
**     Parameters  : None
**     Returns     :
**         ---             - Number of elements in the buffer.
** ===================================================================
*/
byte RxBuf3_NofElements(void)
{
  return RxBuf3_inSize;
}

/*
** ===================================================================
**     Method      :  RxBuf3_NofFreeElements (component RingBufferUInt8)
**
**     Description :
**         Returns the actual number of free elements/space in the
**         buffer.
**     Parameters  : None
**     Returns     :
**         ---             - Number of elements in the buffer.
** ===================================================================
*/
byte RxBuf3_NofFreeElements(void)
{
  return (byte)(RxBuf3_BUF_SIZE-RxBuf3_inSize);
}

/*
** ===================================================================
**     Method      :  RxBuf3_Init (component RingBufferUInt8)
**
**     Description :
**         Initializes the data structure
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void RxBuf3_Init(void)
{
  RxBuf3_inIdx = 0;
  RxBuf3_outIdx = 0;
  RxBuf3_inSize = 0;
}

/* END RxBuf3. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
