/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : TMOUT1.h
**     Project     : ProcessorExpert
**     Processor   : MKL25Z128VLK4
**     Component   : Timeout
**     Version     : Component 01.021, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2012-12-23, 15:30, # CodeGen: 162
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         GetCounter     - TMOUT1_CounterHandle TMOUT1_GetCounter(TMOUT1_CounterType nofTicks);
**         LeaveCounter   - void TMOUT1_LeaveCounter(TMOUT1_CounterHandle handle);
**         Value          - TMOUT1_CounterType TMOUT1_Value(TMOUT1_CounterHandle handle);
**         CounterExpired - bool TMOUT1_CounterExpired(TMOUT1_CounterHandle handle);
**         AddTick        - void TMOUT1_AddTick(void);
**         Init           - void TMOUT1_Init(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2011, all rights reserved.
**     This an open source software implementing timeout routines using Processor Expert.
**     This is a free software and is opened for education,  research  and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for   personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

#ifndef __TMOUT1_H
#define __TMOUT1_H

/* MODULE TMOUT1. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "FRTOS1.h"

#include "Cpu.h"


#ifndef __BWUserType_TMOUT1_CounterType
#define __BWUserType_TMOUT1_CounterType
  typedef int16_t TMOUT1_CounterType ; /* Base type of counter which holds the counting value */
#endif
#ifndef __BWUserType_TMOUT1_CounterHandle
#define __BWUserType_TMOUT1_CounterHandle
  typedef byte TMOUT1_CounterHandle ;  /* Type for the timeout counter handle. */
#endif

#define TMOUT1_OUT_OF_HANDLE 0xff  /* special handle to indicate that we were running out of handlers */
#define TMOUT1_TICK_PERIOD_MS  \
  (1000/100)                            /* Tick period in milliseconds as defined in RTOS component properties, at which TMOUT1._AddTick() is called */


TMOUT1_CounterHandle TMOUT1_GetCounter(TMOUT1_CounterType nofTicks);
/*
** ===================================================================
**     Method      :  TMOUT1_GetCounter (component Timeout)
**
**     Description :
**         Initializes a new timeout counter and returns the handle to
**         it. At the end, use LeaveCounter() to free up the ressource.
**     Parameters  :
**         NAME            - DESCRIPTION
**         nofTicks        - Number of ticks for the counter
**                           until it expires.
**     Returns     :
**         ---             - Handle to the counter, to be used for
**                           further API calls.
** ===================================================================
*/

void TMOUT1_LeaveCounter(TMOUT1_CounterHandle handle);
/*
** ===================================================================
**     Method      :  TMOUT1_LeaveCounter (component Timeout)
**
**     Description :
**         To be called to return the counter. Note that a counter
**         always should be returned so it can be reused.
**     Parameters  :
**         NAME            - DESCRIPTION
**         handle          - Counter handle
**     Returns     : Nothing
** ===================================================================
*/

bool TMOUT1_CounterExpired(TMOUT1_CounterHandle handle);
/*
** ===================================================================
**     Method      :  TMOUT1_CounterExpired (component Timeout)
**
**     Description :
**         Returns true if the timeout counter has been expired
**     Parameters  :
**         NAME            - DESCRIPTION
**         handle          - The timeout handle retrieved using
**                           GetCounter()
**     Returns     :
**         ---             - Returns TRUE if the counter has been
**                           expired, FALSE otherwise
** ===================================================================
*/

void TMOUT1_AddTick(void);
/*
** ===================================================================
**     Method      :  TMOUT1_AddTick (component Timeout)
**
**     Description :
**         Method to be called from a priodic timer or interrupt. It
**         will decrement all current counters by one down to zero.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

void TMOUT1_Init(void);
/*
** ===================================================================
**     Method      :  TMOUT1_Init (component Timeout)
**
**     Description :
**         Initialization of the driver
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

TMOUT1_CounterType TMOUT1_Value(TMOUT1_CounterHandle handle);
/*
** ===================================================================
**     Method      :  TMOUT1_Value (component Timeout)
**
**     Description :
**         Return the current value of the counter (in ticks)
**     Parameters  :
**         NAME            - DESCRIPTION
**         handle          - Handle of the timeout counter
**     Returns     :
**         ---             - none
** ===================================================================
*/

/* END TMOUT1. */

#endif
/* ifndef __TMOUT1_H */
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
